JUCE: IIRFilterAudioSource Class Reference

JUCE

Public Member Functions | List of all members
IIRFilterAudioSource Class Reference
juce_audio_basics » sources

An AudioSource that performs an IIR filter on another source. More...

`#include <juce_IIRFilterAudioSource.h>`

Inheritance diagram for IIRFilterAudioSource:

## Public Member Functions
| IIRFilterAudioSource (AudioSource *inputSource, bool deleteInputWhenDeleted)
| Creates a IIRFilterAudioSource for a given input source. More...
| ~IIRFilterAudioSource () override
| Destructor. More...
void | setCoefficients (const IIRCoefficients &newCoefficients)
| Changes the filter to use the same parameters as the one being passed in. More...
void | makeInactive ()
| Calls IIRFilter::makeInactive() on all the filters being used internally. More...
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
| Tells the source to prepare for playing. More...
void | releaseResources () override
| Allows the source to release anything it no longer needs after playback has stopped. More...
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
| Called repeatedly to fetch subsequent blocks of audio data. More...
Public Member Functions inherited from AudioSource
virtual | ~AudioSource ()=default
| Destructor. More...
virtual void | prepareToPlay (int samplesPerBlockExpected, double sampleRate)=0
| Tells the source to prepare for playing. More...
virtual void | releaseResources ()=0
| Allows the source to release anything it no longer needs after playback has stopped. More...
virtual void | getNextAudioBlock (const AudioSourceChannelInfo &bufferToFill)=0
| Called repeatedly to fetch subsequent blocks of audio data. More...

## Additional Inherited Members
Protected Member Functions inherited from AudioSource
| AudioSource ()=default
| Creates an AudioSource. More...

## Detailed Description

An AudioSource that performs an IIR filter on another source.

## Constructor & Destructor Documentation

## ◆ IIRFilterAudioSource()

IIRFilterAudioSource::IIRFilterAudioSource | ( | AudioSource * | inputSource,
|  | bool | deleteInputWhenDeleted
| ) |  |

Creates a IIRFilterAudioSource for a given input source.

Parameters

  inputSource | the input source to read from - this must not be null
  deleteInputWhenDeleted | if true, the input source will be deleted when this object is deleted

## ◆ ~IIRFilterAudioSource()

IIRFilterAudioSource::~IIRFilterAudioSource | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setCoefficients()

void IIRFilterAudioSource::setCoefficients | ( | const IIRCoefficients & | newCoefficients | ) |

Changes the filter to use the same parameters as the one being passed in.

## ◆ makeInactive()

void IIRFilterAudioSource::makeInactive | ( |  | ) |

Calls IIRFilter::makeInactive() on all the filters being used internally.

## ◆ prepareToPlay()

void IIRFilterAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate
| ) |  |
| overridevirtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements AudioSource.

## ◆ releaseResources()

void IIRFilterAudioSource::releaseResources | ( |  | ) |
| overridevirtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements AudioSource.

## ◆ getNextAudioBlock()

void IIRFilterAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |
| overridevirtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements AudioSource.

The documentation for this class was generated from the following file:

- juce_IIRFilterAudioSource.h